import SqlliteDbUtil from "@/utils/sqllitedb";
import table from "./sqllite/table.js";
import {
	fixNullVal
} from "@/utils/common";

// 巡检
export default {

	async selectList() {
		let sqllitedb = await SqlliteDbUtil.initSqlliteDB();
		try {
			let rs = await sqllitedb.selectSQL(`select * from ${table.assRoomName}`);
			return rs;
		} catch (e) {
			console.log(e.message)
		} finally {
			await sqllitedb.closeDB();
		}

	},

	async selectRoomList(roomType = 1) {
		let sqllitedb = await SqlliteDbUtil.initSqlliteDB();
		try {
			let rs = await sqllitedb.selectSQL(
				`select * from ${table.assRoomName} where roomType = ${roomType}`
			);
			return rs;
		} catch (e) {
			console.log(e.message)
		} finally {
			await sqllitedb.closeDB();
		}

	},

	async info(id) {
		let sqllitedb = await SqlliteDbUtil.initSqlliteDB();
			let sql = `select * from ${table.assRoomName} where id = '${id}'`;
			let res = await sqllitedb.selectSQL(sql);
			if (res && res.length > 0) {
				return res[0];
			}
			return null;
	},
	async remove(id) {
		if (!id) {
			return;
		}
		let sql = `delete from ${table.assRoomName} where id = '${id}'`;
			let sqllitedb = await SqlliteDbUtil.initSqlliteDB();
			await sqllitedb.executeSQL(sql);

	},
	async saveBatch(list) {
		if (list.length === 0) {
			return;
		}
		console.log('开始保存巡检信息....' + list)
		let sqllitedb = await SqlliteDbUtil.initSqlliteDB()
		try {
			for (let data of list) {
				let column = ''
				let values = ''
				let idx = 0
				for (let attr in data) {
					let dataField = table['assRoom'].find(v => {

						if (v.field === attr) {
							return v
						}
					})
					if (!dataField) {
						continue
					}
					column += dataField.field + ','
					values += "'" + fixNullVal(data[attr]) + "',"
					idx++
				}

				column = column.endsWith(',') ? column.substring(0, column.length - 1) : column
				values = values.endsWith(',') ? values.substring(0, values.length - 1) : values

				let sql = `insert into ${table.assRoomName}(${column}) values(${values})`
				let has = await this.info(data.id)
				if (has && has.id) {
					await this.remove(data.id)
				}
				await sqllitedb.executeSQL(sql)
			}
		} catch (e) {
			console.log(e.message)
		} finally {
			await sqllitedb.closeDB();
		}
		console.log('导入完成...')
	}
};